diff -urpN john-1.7.8-jumbo-6a/src/zip2john.c john-1.7.8-jumbo-6b/src/zip2john.c
--- john-1.7.8-jumbo-6a/src/zip2john.c	2011-09-01 15:26:21.031250000 +0000
+++ john-1.7.8-jumbo-6b/src/zip2john.c	2011-09-09 20:44:27.000000000 +0000
@@ -5,12 +5,9 @@
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted.
  *
- * Updated in Aug 2011 by Jim Fougeron.  Added PKZIP 'old' encryption.  The signature
- * on the pkzip will be $pkzip1$ and does not look like the AES version written by Dhiru
+ * Updated in Aug 2011 by JimF.  Added PKZIP 'old' encryption.  The signature on the
+ * pkzip will be $pkzip$ and does not look like the AES version written by Dhiru
  * Also fixed some porting issues, such as variables needing declared at top of blocks.
- * Added a -a= switch for 'old' format.  That allows a user to give a hint that a specific
- * file 'is' known to be ASCII.  This allows john to have a significant performance
- * improvement when there are no small files.
  *
  * References:
  *
@@ -36,58 +33,28 @@
  * For type = 0, for ZIP files encrypted using AES
  * filename:$zip$*type*hex(CRC)*encryption_strength*hex(salt)*hex(password_verfication_value):hex(authentication_code)
  *
- * For pkzip type:  (JimF, with longer explaination of fields)
- * filename:$pkzip1$C*B*F*H*[H*[H*...]]*AL*AT*AD*crc*cmplen*decomplen*compType*offset*filename*intfilename*filedata*
+ * For original pkzip encryption:  (JimF, with longer explaination of fields)
+ * filename:$pkzip$C*B*[DT*MT{CL*UL*CR*OF*OX}*CT*DL*DA]*$/pkzip$
  *
  * All numeric and 'binary data' fields are stored in hex.
  *
- * C  is the count of hashes present (the H's.).
- * B  is number of valid bytes in the checksum (1 or 2).  Unix zip is 2 bytes, all others are 1
- * F  is a set of flags. The bits of the flag list which fields following the array of H's should have data.
- * H  is a 'hash'. This is the first 12 bytes of the encrypted imploded data blob (the IV), and also the 2 bytes of checksum,
- *    either from the CRC32 of the file, or the Dos timestamp. There can be up to 8 of these (if there are 8 encrypted files
- *    in the .zip file, and this 'assumes' that all files have the same password.
- * AL is the 'length' of the ASCII compressed file blob.  This assumes that there is a 'known to be' total ASCII text file
- *    encrypted in the zip.  Only a tiny part of the start of the file is decrypted and decompressed. Then if that decompressed
- *    data is 'all' ASCII items, then that is a better validation than a checksum match.
- * AT is the 'type' of compression. Only 0 or 8 are handled (store or inflate)
- * AD This is the compressed ASCII data.  It is the first 12 bytes (the IV), of the imploded data of the ASCII file, and some
- *    more.  80-90 bytes is more than adequate.  This number may be reduced, if it speeds things up in the end.
- * CRC32       This is the crc of the 'whole' file we have to test
- * Compr_len   This is the length of compressed data (the test-3 full test data).
- * deComp_len  The length of the decompressed data (full file test data).
- * compType    is the 'type' of compression. Only 0 or 8 are handled (store or inflate)
- * Offset      This is the offset of this data within the .zip file. If the file is too large, then it can not be placed into
- *             the john input line.  If that is the case, the .zip file must be present (name listed next), and when john
- *             runs, it will load the zip data.
- * FileName    The name of the .zip file (can contain path's).
- * IntFileName This is the name of the compressed/encrypted file within the .zip.  This is needed if we spawn out to unzip -P
- *             to perform the test (this field may go away.
- * FileData    We can provide the file data, if it is small enough.  NOTE the file should be a couple hundred bytes long at
- *             least, to make it MUCH more unlikely that we could decrypt/explode/crc and have proper size and crc.  If the
- *             file data is provided, then the Offset/FileName/IntFileName are not needed.
- *
- * NOTE the flags field lists which of the above fields are present in the hash.  NOTE, it is valid to have only the hashes
- * (the 'H' data) present.  John will be able to crack based only upon that.  Within the format, many of the test vectors
- * are Hash only.
-
- * There are 3 'test' items in a file.  The more of these that are present, the less likely it is to have false positive
- *   passwords.
- * The first is the checksum hash. There can be up to 8 of these hashes.  The hashes may have 1 or 2 bytes that 'match'
- *   in the checksum.  The 2 byte checksums provide much stronger 'pre' validation.  If there are enough of these
- *   checksums, then this may be all the data needed.  This is the array of 'H' data.  Unix (info-zip) makes zips
- *   which have 2 bytes valid in the checksum (and the checksum checks against the dos-timestamp). Winzip and pkzip 2.00+
- *   both only have 1 byte of valid checksum data, and it is the LSB of the CRC field.
- * The second (optional), is the first part of a 'text' file. If there is a file that is KNOWN to be pure ASCII
- *   text, then we can grab the first small part of the encrypted/compressed data, decrypt it, decompress it, and
- *   see if all the data is ASCII (ignoring the last couple of bytes).  This is not perfect, but may be very fast,
- *   compared to step 3 if all files are LARGE, and it eliminates almost ALL false positives that passed the
- *   checksum checks.   This is the AL and AD data, and is optional.
- * The 3rd part, is an entire compressed data blob, it's length it's CRC32.  This is the real 'test'.  The file should
- *   have a certain minimum size, say 100 bytes, decompressed.  john will either spawn unzip -P to test the .zip file
- *   or will perform the full decryption of the data blob, the full explosion of the data blob, and if the length matches
- *   what it is supposed to, and the CRC of the decompressed data blob matches, THEN we know we have the password found.
- *
+ * C   is the count of hashes present (the array of items, inside the []  C can be 1 to 3.).
+ * B   is number of valid bytes in the checksum (1 or 2).  Unix zip is 2 bytes, all others are 1
+ * ARRAY of data starts here
+ *   DT  is a "Data Type enum".  This will be 1 2 or 3.  1 is 'partial'. 2 and 3 are full file data (2 is inline, 3 is load from file).
+ *   MT  Magic Type enum.  0 is no 'type'.  255 is 'text'. Other types (like MS Doc, GIF, etc), see source.
+ *     NOTE, CL, DL, CRC, OFF are only present if DT != 1
+ *     CL  Compressed length of file blob data (includes 12 byte IV).
+ *     UL  Uncompressed length of the file.
+ *     CR  CRC32 of the 'final' file.
+ *     OF  Offset to the PK\x3\x4 record for this file data. If DT==2, then this will be a 0, as it is not needed, all of the data is already included in the line.
+ *     OX  Additional offset (past OF), to get to the zip data within the file.
+ *     END OF 'optional' fields.
+ *   CT  Compression type  (0 or 8)  0 is stored, 8 is imploded.
+ *   DL  Length of the DA data.
+ *   DA  This is the 'data'.  It will be hex data if DT==1 or 2. If DT==3, then it is a filename (name of the .zip file).
+ * END of array item.  There will be C (count) array items.
+ * The format string will end with $/pkzip$
  */
 
 #include <stdio.h>
@@ -98,11 +65,15 @@
 #include <string.h>
 #include <assert.h>
 #include "common.h"
+#include "misc.h"
+#include "formats.h"
 
-static int ascii_mode=0;
-static int checksum_only=0;
+static int ascii_mode=0, checksum_only=0;
 static char *ascii_fname;
 
+static char *MagicTypes[]= { "", "DOC", "XLS", "DOT", "XLT", "EXE", "DLL", "ZIP", "BMP", "DIB", "GIF", "PDF", "GZ", "TGZ", "BZ2", "TZ2", "FLV", "SWF", "MP3", NULL };
+static int  MagicToEnum[] = {0,  1,    1,     1,     1,     2,     2,     3,     4,     4,     5,     6,     7,    7,     8,     8,     9,     10,    11,  0};
+
 /* helper functions for byte order conversions, header values are stored
  * in little-endian byte order */
 static uint32_t fget32(FILE * fp)
@@ -161,7 +132,10 @@ static void process_file(const char *fna
 			(void) crc;
 			(void) uncompressed_size;
 
-			fread(filename, 1, filename_length, fp);
+			if (fread(filename, 1, filename_length, fp) != filename_length) {
+				fprintf(stderr, "Error, in fread of file data!\n");
+				goto cleanup;
+			}
 			filename[filename_length] = 0;
 
 			if (compression_method == 99) {	/* AES encryption */
@@ -192,15 +166,24 @@ static void process_file(const char *fna
 				switch (efh_aes_strength) {
 				case 1:
 					n = 8;
-					fread(salt, 1, n, fp);
+					if (fread(salt, 1, n, fp) != n) {
+						fprintf(stderr, "Error, in fread of file data!\n");
+						goto cleanup;
+					}
 					break;
 				case 2:
 					n = 12;
-					fread(salt, 1, n, fp);
+					if (fread(salt, 1, n, fp) != n) {
+						fprintf(stderr, "Error, in fread of file data!\n");
+						goto cleanup;
+					}
 					break;
 				case 3:
 					n = 16;
-					fread(salt, 1, n, fp);
+					if (fread(salt, 1, n, fp) != n) {
+						fprintf(stderr, "Error, in fread of file data!\n");
+						goto cleanup;
+					}
 					break;
 
 				}
@@ -242,31 +225,147 @@ cleanup:
 	fclose(fp);
 }
 
-static void process_old_zip(const char *fname) {
-	/* instead of using anything from the process_file, we simply detected a encrypted old style
-	   password, close the file, and call this function.  This function handles the older pkzip
-	   password, while the process_file handles ONLY the AES from WinZip */
+/* instead of using anything from the process_file, we simply detected a encrypted old style
+ * password, close the file, and call this function.  This function handles the older pkzip
+ * password, while the process_file handles ONLY the AES from WinZip 
+ */
+typedef struct _zip_ptr
+{
+	uint16_t      magic_type, cmptype;
+	uint32_t      offset, offex, crc, cmp_len, decomp_len;
+	char          chksum[5];
+	char         *hash_data;
+} zip_ptr;
+typedef struct _zip_file
+{
+	int unix_made;
+	int check_in_crc;
+	int two_byte_check;
+} zip_file;
+
+static int magic_type(const char *filename) {
+	char *Buf = str_alloc_copy((char*)filename), *cp;
+	int i;
 
+	strupr(Buf);
+	if (ascii_fname && !strcasecmp(Buf, ascii_fname)) 
+		return 255;
+
+	cp = strrchr(Buf, '.');
+	if (!cp) return 0;
+	++cp;
+	for (i = 1; MagicTypes[i]; ++i)
+		if (!strcmp(cp, MagicTypes[i]))
+			return MagicToEnum[i];
+	return 0;
+}
+static char *toHex(unsigned char *p, int len) {
+	static char Buf[4096];
+	char *cp = Buf;
+	int i;
+	for (i = 0; i < len; ++i)
+		cp += sprintf(cp, "%02x", p[i]);
+	return Buf;
+}
+static int LoadZipBlob(FILE *fp, zip_ptr *p, zip_file *zfp, const char *zip_fname)
+{
+	uint16_t version,flags,lastmod_time,lastmod_date,filename_length,extrafield_length;
 	unsigned char filename[1024];
-	unsigned char H[12];
-	char building_hash[29*8+1];  // store up to 8 hashes. They are 12 bytes + 2 bytes (in hex), which is 28 bytes, and the '*' char (and +1 for the null byte).
-	char *pbuilding_hash=building_hash;
-	int count_of_hashes = 0;
-	FILE *fp;
-	char *FileData = "";
-	int unix_made=0, check_in_crc = 1, two_byte_check = 0;
-	unsigned Flag_bits = 1;
-	// todo.
-	unsigned AL=0, AT=0;
-	char *AD = "";
-	char sAL[8] = {0}, sAT[8] = {0};
 
-	uint32_t best_size=0xFFFFFFFF, best_off=0, best_crc=0, best_cmp_size=0;
-	char best_filename[1024]={0}, best_str_off[20]={0}, best_fname[1024]={0}, best_type[8]={0};
+	memset(p, 0, sizeof(*p));
+
+	p->offset = ftell(fp)-4;
+	version = fget16(fp);
+	flags = fget16(fp);
+	p->cmptype = fget16(fp);
+	lastmod_time = fget16(fp);
+	lastmod_date = fget16(fp);
+	p->crc = fget32(fp);
+	p->cmp_len= fget32(fp);
+	p->decomp_len = fget32(fp);
+	filename_length = fget16(fp);
+	extrafield_length = fget16(fp);
+	/* unused variables */
+	(void) lastmod_date;
+
+	if (fread(filename, 1, filename_length, fp) != filename_length) {
+		fprintf(stderr, "Error, fread could not read the data from the file:  %s\n", zip_fname);
+		return 0;
+	}
+	filename[filename_length] = 0;
+	p->magic_type = magic_type((char*)filename);
+
+	p->offex = 30 + filename_length + extrafield_length;
+
+	// we only handle implode or store.
+	if ( (version == 0x14||version==0xA) && (flags & 1) && (p->cmptype == 8 || p->cmptype == 0)) {
+		uint16_t extra_len_used = 0;
+		if (flags & 8) {
+			while (extra_len_used < extrafield_length) {
+				uint16_t efh_id = fget16(fp);
+				uint16_t efh_datasize = fget16(fp);
+				extra_len_used += 4 + efh_datasize;
+				fseek(fp, efh_datasize, SEEK_CUR);
+				//http://svn.assembla.com/svn/os2utils/unzip60f/proginfo/extrafld.txt
+				//http://emerge.hg.sourceforge.net/hgweb/emerge/emerge/diff/c2f208617d32/Source/unzip/proginfo/extrafld.txt
+				if (efh_id == 0x07c8 ||  // Info-ZIP Macintosh (old, J. Lee)
+					efh_id == 0x334d ||  // Info-ZIP Macintosh (new, D. Haase's 'Mac3' field)
+					efh_id == 0x4d49 ||  // Info-ZIP OpenVMS (obsolete)
+					efh_id == 0x5855 ||  // Info-ZIP UNIX (original; also OS/2, NT, etc.)
+					efh_id == 0x6375 ||  // Info-ZIP UTF-8 comment field
+					efh_id == 0x7075 ||  // Info-ZIP UTF-8 name field
+					efh_id == 0x7855 ||  // Info-ZIP UNIX (16-bit UID/GID info)
+					efh_id == 0x7875)    // Info-ZIP UNIX 3rd generation (generic UID/GID, ...)
+
+					// 7zip ALSO is 2 byte checksum, but I have no way to find them.  NOTE, it is 2 bytes of CRC, not timestamp like InfoZip.
+					// OLD winzip (I think 8.01 or before), is also supposed to be 2 byte.
+					// old v1 pkzip (the DOS builds) are 2 byte checksums.
+				{
+					zfp->unix_made = 1;
+					zfp->two_byte_check = 1;
+					zfp->check_in_crc = 0;
+				}
+			}
+		}
+		else if (extrafield_length)
+			fseek(fp, extrafield_length, SEEK_CUR);
+
+		fprintf(stderr,
+			"%s->%s PKZIP Encr:%s%s cmplen=%d, decmplen=%d, crc=%X\n",
+			zip_fname, filename, zfp->two_byte_check?" 2b chk,":"", zfp->check_in_crc?"":" TS_chk,", p->cmp_len, p->decomp_len, p->crc);
+
+		p->hash_data = mem_alloc_tiny(p->cmp_len+1, MEM_ALIGN_WORD);
+		if (fread(p->hash_data, 1, p->cmp_len, fp) != p->cmp_len) {
+			fprintf(stderr, "Error, fread could not read the data from the file:  %s\n", zip_fname);
+			return 0;
+		}
+
+		// Ok, now set checksum bytes.  This will depend upon if from crc, or from timestamp
+		if (zfp->check_in_crc)
+			sprintf (p->chksum, "%02x%02x", (p->crc>>24)&0xFF, (p->crc>>16)&0xFF);
+		else
+			sprintf(p->chksum, "%02x%02x", lastmod_time>>8, lastmod_time&0xFF);
+
+		return 1;
+
+	}
+	fprintf(stderr, "%s->%s is not encrypted, or stored with non-handled compression type\n", zip_fname, filename);
+	fseek(fp, extrafield_length, SEEK_CUR);
+	fseek(fp, p->cmp_len, SEEK_CUR);
+
+	return 0;
+}
+
+static void process_old_zip(const char *fname)
+{
+	FILE *fp;
 
-	strcpy(best_fname, fname);
+	int count_of_hashes = 0;
+	zip_ptr hashes[3], curzip;
+	zip_file zfp;
 
-	memset(building_hash, 0, sizeof(building_hash));
+	zfp.check_in_crc = 1;
+	zfp.two_byte_check = zfp.unix_made = 0;
 
 	if (!(fp = fopen(fname, "rb"))) {
 		fprintf(stderr, "! %s : %s\n", fname, strerror(errno));
@@ -277,100 +376,76 @@ static void process_old_zip(const char *
 		uint32_t id = fget32(fp);
 
 		if (id == 0x04034b50UL) {	/* local header */
-			uint16_t version = fget16(fp);
-			uint16_t flags = fget16(fp);
-			uint16_t compression_method = fget16(fp);
-			uint16_t lastmod_time = fget16(fp);
-			uint16_t lastmod_date = fget16(fp);
-			uint32_t crc = fget32(fp);
-			uint32_t compressed_size = fget32(fp);
-			uint32_t uncompressed_size = fget32(fp);
-			uint16_t filename_length = fget16(fp);
-			uint16_t extrafield_length = fget16(fp);
-			/* unused variables */
-			(void) lastmod_date;
-
-			fread(filename, 1, filename_length, fp);
-			filename[filename_length] = 0;
-
-			// we only handle implode or store.
-			if ( (version == 0x14||version==0xA) && (flags & 1) && (compression_method == 8 || compression_method == 0)) {
-				uint16_t extra_len_used = 0;
-				if (flags & 8) {
-					while (extra_len_used < extrafield_length) {
-						uint16_t efh_id = fget16(fp);
-						uint16_t efh_datasize = fget16(fp);
-						extra_len_used += 4 + efh_datasize;
-						fseek(fp, efh_datasize, SEEK_CUR);
-						//http://svn.assembla.com/svn/os2utils/unzip60f/proginfo/extrafld.txt
-						//http://emerge.hg.sourceforge.net/hgweb/emerge/emerge/diff/c2f208617d32/Source/unzip/proginfo/extrafld.txt
-						if (efh_id == 0x07c8 ||  // Info-ZIP Macintosh (old, J. Lee)
-							efh_id == 0x334d ||  // Info-ZIP Macintosh (new, D. Haase's 'Mac3' field)
-							efh_id == 0x4d49 ||  // Info-ZIP OpenVMS (obsolete)
-							efh_id == 0x5855 ||  // Info-ZIP UNIX (original; also OS/2, NT, etc.)
-							efh_id == 0x6375 ||  // Info-ZIP UTF-8 comment field
-							efh_id == 0x7075 ||  // Info-ZIP UTF-8 name field
-							efh_id == 0x7855 ||  // Info-ZIP UNIX (16-bit UID/GID info)
-							efh_id == 0x7875)    //  Info-ZIP UNIX 3rd generation (generic UID/GID, ...)
-						{
-							unix_made = 1;
-							two_byte_check = 1;
-							check_in_crc = 0;
+			if (LoadZipBlob(fp, &curzip, &zfp, fname) && curzip.decomp_len > 12) {
+				if (!count_of_hashes)
+					memcpy(&(hashes[count_of_hashes++]), &curzip, sizeof(curzip));
+				else {
+					if (count_of_hashes == 1) {
+						if (curzip.cmp_len < hashes[0].cmp_len) {
+							memcpy(&(hashes[count_of_hashes++]), &(hashes[0]), sizeof(curzip));
+							memcpy(&(hashes[0]), &curzip, sizeof(curzip));
+						} else
+							memcpy(&(hashes[count_of_hashes++]), &curzip, sizeof(curzip));
+					}
+					else if (count_of_hashes == 2) {
+						if (curzip.cmp_len < hashes[0].cmp_len) {
+							memcpy(&(hashes[count_of_hashes++]), &(hashes[1]), sizeof(curzip));
+							memcpy(&(hashes[1]), &(hashes[0]), sizeof(curzip));
+							memcpy(&(hashes[0]), &curzip, sizeof(curzip));
+						} else if (curzip.cmp_len < hashes[1].cmp_len) {
+							memcpy(&(hashes[count_of_hashes++]), &(hashes[1]), sizeof(curzip));
+							memcpy(&(hashes[1]), &curzip, sizeof(curzip));
+						} else
+							memcpy(&(hashes[count_of_hashes++]), &curzip, sizeof(curzip));
+					}
+					else {
+						int done=0;
+						if (curzip.magic_type && curzip.cmp_len > hashes[0].cmp_len) {
+							// if we have a magic type, we will replace any NON magic type, for the 2nd and 3rd largest, without caring about
+							// the size.
+							if (hashes[1].magic_type == 0) {
+								if (hashes[2].cmp_len < curzip.cmp_len) {
+									memcpy(&(hashes[1]), &(hashes[2]), sizeof(curzip));
+									memcpy(&(hashes[2]), &curzip, sizeof(curzip));
+									done=1;
+								} else {
+									memcpy(&(hashes[1]), &curzip, sizeof(curzip));
+									done=1;
+								}
+							} else if (hashes[2].magic_type == 0) {
+								if (hashes[1].cmp_len < curzip.cmp_len) {
+									memcpy(&(hashes[2]), &curzip, sizeof(curzip));
+									done=1;
+								} else {
+									memcpy(&(hashes[2]), &(hashes[1]), sizeof(curzip));
+									memcpy(&(hashes[1]), &curzip, sizeof(curzip));
+									done=1;
+								}
+							}
+						}
+						if (!done && curzip.cmp_len < hashes[0].cmp_len) {
+							// we 'only' replace the smallest zip, and always keep as many any other magic as possible.
+							if (hashes[0].magic_type == 0)
+								memcpy(&(hashes[0]), &curzip, sizeof(curzip));
+							else {
+								// Ok, the 1st is a magic, we WILL keep it.
+								if (hashes[1].magic_type) {  // Ok, we found our 2
+									memcpy(&(hashes[2]), &(hashes[1]), sizeof(curzip));
+									memcpy(&(hashes[1]), &(hashes[0]), sizeof(curzip));
+									memcpy(&(hashes[0]), &curzip, sizeof(curzip));
+								} else if (hashes[2].magic_type) {  // Ok, we found our 2
+									memcpy(&(hashes[1]), &(hashes[0]), sizeof(curzip));
+									memcpy(&(hashes[0]), &curzip, sizeof(curzip));
+								} else {
+									// found none.  So we will simply roll them down (liek when #1 was a magic also).
+									memcpy(&(hashes[2]), &(hashes[1]), sizeof(curzip));
+									memcpy(&(hashes[1]), &(hashes[0]), sizeof(curzip));
+									memcpy(&(hashes[0]), &curzip, sizeof(curzip));
+								}
+							}
 						}
 					}
 				}
-				else if (extrafield_length)
-					fseek(fp, extrafield_length, SEEK_CUR);
-
-				fprintf(stderr,
-					"%s->%s PKZIP Encr:%s%s cmplen=%d, decmplen=%d, crc=%X\n",
-					fname, filename, two_byte_check?" 2b chk,":"", check_in_crc?"":" TS_chk,", compressed_size, uncompressed_size, crc);
-
-				if (!checksum_only && uncompressed_size > 24 && uncompressed_size < best_size) {
-					best_size=uncompressed_size;
-					best_off=ftell(fp);
-					best_crc=crc;
-					best_cmp_size=compressed_size;
-					strcpy(best_filename, (char*)filename);
-					sprintf(best_type, "%x", compression_method);
-				}
-
-				if (!checksum_only && ascii_mode && !strcmp((char*)filename, ascii_fname)) {
-					long whence = ftell(fp);
-					unsigned char Buf[128+12+1];
-					AL = 128+12;
-					if (compressed_size < 128+12)
-						AL = compressed_size;
-					AT = compression_method;
-					fread(Buf, 1, AL, fp);
-					fseek(fp, whence, SEEK_SET);
-					AD = mem_alloc_tiny( (AL<<1)+1, MEM_ALIGN_NONE);
-					convert_to_hex(AD, Buf, AL);
-					sprintf(sAL, "%x", AL);
-					sprintf(sAT, "%x", AT);
-					Flag_bits |= 2;
-					Flag_bits &= (~1); // remove the 'checksum' only flag bit.
-				}
-				if (count_of_hashes < 8 && compressed_size > 14) {
-					fread(H, 1, 12, fp);
-					fseek(fp, compressed_size-12, SEEK_CUR);
-					if (pbuilding_hash != building_hash)
-						*pbuilding_hash++ = '*';
-					pbuilding_hash += convert_to_hex(pbuilding_hash, H, 12);
-					if (!check_in_crc)
-						sprintf (pbuilding_hash, "%02x%02x", lastmod_time>>8, lastmod_time&0xFF);
-					else
-						sprintf (pbuilding_hash, "%02x%02x", (crc>>24)&0xFF, (crc>>16)&0xFF);
-					pbuilding_hash += 4;
-					++count_of_hashes;
-				}
-				else
-					fseek(fp, compressed_size, SEEK_CUR);
-
-			} else {
-				fprintf(stderr, "%s->%s is not encrypted, or stored with non-handled compression type\n", fname, filename);
-				fseek(fp, extrafield_length, SEEK_CUR);
-				fseek(fp, compressed_size, SEEK_CUR);
 			}
 		} else if (id == 0x08074b50UL) {	/* data descriptor */
 			fseek(fp, 12, SEEK_CUR);
@@ -380,42 +455,31 @@ static void process_old_zip(const char *
 	}
 
 print_and_cleanup:;
-
-	sprintf (best_str_off, "%x", best_off);
-	if (!checksum_only && best_cmp_size != 0xFFFFFFFF) {
-		Flag_bits |= (4|8);
-		Flag_bits &= (~1); // remove the checksum only bit.
-	}
-	if (!checksum_only && best_cmp_size < 1400) {
-		// we can store the whole ZIP BLOB in the hash line.
-		unsigned char Buf[1400];
-		static char sBuf[2801];
-		// remove bit 3 and set bit 4
-		Flag_bits &= (~8);
-		Flag_bits |= 16;
-		fseek(fp, best_off, SEEK_SET);
-		fread(Buf, 1, best_cmp_size, fp);
-		convert_to_hex(sBuf, Buf, best_cmp_size);
-		FileData = sBuf;
-		best_off = 0;
-		// now, 'remove' the offset, the zip name and the internal file name, since we are storing the 'real' data.
-		*best_filename = 0;
-		*best_fname = 0;
-		*best_str_off = 0;
-
-		if (best_cmp_size < 128+12) // in this case, simply skip doing ANY ascii checking, and run right to the final checking.
-		{
-			Flag_bits &= (~2);
-			AD = "";
-			*sAL = 0;
-			*sAT = 0;
+	if (count_of_hashes) {
+		int i=1;
+		printf ("$pkzip$%x*%x*", count_of_hashes, zfp.two_byte_check?2:1);
+		if (checksum_only)
+			i = 0;
+		for (; i < count_of_hashes; ++i) {
+			int len = 12+24;
+			if (hashes[i].magic_type)
+				len = 12+180;
+			if (len > hashes[i].cmp_len)
+				len = hashes[i].cmp_len; // even though we 'could' output a '2', we do not.  We only need one full inflate CRC check file.
+			printf("1*%x*%x*%x*%s*%s*", hashes[i].magic_type, hashes[i].cmptype, len, hashes[i].chksum, toHex((unsigned char*)hashes[i].hash_data, len));
+		}
+		// Ok, now output the 'little' one (the first).
+		if (checksum_only)
+			printf ("\n");
+		else {
+			printf("%x*%x*%x*%x*%x*%x*%x*%x*", hashes[0].cmp_len<1500?2:3, hashes[0].magic_type, hashes[0].cmp_len, hashes[0].decomp_len, hashes[0].crc, hashes[0].offset, hashes[0].offex, hashes[0].cmptype);
+			if (hashes[0].cmp_len<1500)
+				printf("%x*%s*%s*", hashes[0].cmp_len, hashes[0].chksum, toHex((unsigned char*)hashes[0].hash_data, hashes[0].cmp_len));
+			else
+				printf("%x*%s*%s*", strlen(fname), hashes[0].chksum, fname);
 		}
+		printf("$/pkzip$\n");
 	}
-	printf ("%s:$pkzip1$%x*%x*%x*%s*", fname, count_of_hashes, two_byte_check+1, Flag_bits, building_hash);
-	if (checksum_only)
-		printf("***********\n");
-	else
-		printf("%s*%s*%s*%x*%x*%x*%s*%s*%s*%s*%s*\n", sAL, sAT, AD, best_crc, best_cmp_size, best_size, best_type, best_str_off, best_fname, best_filename, FileData );
 	fclose(fp);
 }
 
